package com.example.restexample.ui;

import com.example.restexample.security.SecurityService;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.notification.Notification;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.router.PageTitle;
import com.vaadin.flow.router.Route;
import com.vaadin.flow.router.RouteAlias;

import jakarta.annotation.security.PermitAll;

@PageTitle("Hello World")
@Route(value = "hello")
@RouteAlias(value = "")
@PermitAll
public class HelloWorldView extends HorizontalLayout {

   private TextField name;
   private Button sayHello;
   private Button logoutButton;

   public HelloWorldView(SecurityService service) {
      name = new TextField("Your name");
      sayHello = new Button("Say hello");
      sayHello.addClickListener(e -> {
         Notification.show("Hello " + name.getValue());
      });
      sayHello.addClickShortcut(Key.ENTER);

      logoutButton = new Button("Logout");
      logoutButton.addClickListener(event -> service.logout());

      setMargin(true);
      setVerticalComponentAlignment(Alignment.END, name, sayHello, logoutButton);

      add(name, sayHello, logoutButton);
   }

}
