package com.example.restexample.ui;

import com.vaadin.flow.component.Text;
import com.vaadin.flow.component.html.H1;
import com.vaadin.flow.component.login.LoginForm;
import com.vaadin.flow.component.orderedlayout.VerticalLayout;
import com.vaadin.flow.router.BeforeEnterEvent;
import com.vaadin.flow.router.BeforeEnterObserver;
import com.vaadin.flow.router.PageTitle;
import com.vaadin.flow.router.Route;
import com.vaadin.flow.server.auth.AnonymousAllowed;

@Route(value = "login")
@PageTitle("Example Vaadin & Spring-boot-rest")
@AnonymousAllowed
public class LoginView extends VerticalLayout implements BeforeEnterObserver {

   private final LoginForm login = new LoginForm();

   public LoginView() {
      addClassName("login-view");
      setSizeFull();
      setAlignItems(Alignment.CENTER);
      setJustifyContentMode(JustifyContentMode.CENTER);

      login.setAction("login");

      add(new H1("Vaadin Spring-Boot-REST"), new Text("login with 'admin' / 'admin'"), login);
   }

   @Override
   public void beforeEnter(BeforeEnterEvent beforeEnterEvent) {
      // inform the user about an authentication error
      if (beforeEnterEvent.getLocation()
            .getQueryParameters()
            .getParameters()
            .containsKey("error")) {
         login.setError(true);
      }
   }
}